/* html tag scanner */

/* start conditions */
%x TABLE_TAG SCRIPT_TAG ANCHOR_TAG IMAGE_TAG TAG
%x TABLE_STRING SCRIPT_STRING ANCHOR_STRING IMAGE_STRING TAG_STRING

/* we want a case insensitive scanner */
%option case-insensitive

%%
 /* patterns */

 /* comment */
"<!--"             BEGIN_BLOCK("comment", 5, TRUE);
"-->"              END_BLOCK("comment");

\</\<
 /* table tags */
\</[ \t]*\/?("table"|"tr"|"td")    BEGIN_BLOCK("table_tag", 0, TRUE); BEGIN(TABLE_TAG);

 /* script tag */
\</[ \t]*\/?"script"               BEGIN_BLOCK("script_tag", 0, TRUE); BEGIN(SCRIPT_TAG);

 /* anchor tag */
\</[ \t]*\/?"a"                    BEGIN_BLOCK("anchor_tag", 0, TRUE); BEGIN(ANCHOR_TAG);

 /* image tag */
\</[ \t]*\/?"img"                  BEGIN_BLOCK("image_tag", 0, TRUE); BEGIN(IMAGE_TAG);

  /* general tag */
\<                                 BEGIN_BLOCK("tag", 0, TRUE); BEGIN(TAG);

 /* inner tag handlers */
<TABLE_TAG>{
(.|\n)/\<       END_BLOCK("table_tag"); BEGIN(INITIAL);
\"         BEGIN_BLOCK("string", 1, FALSE); BEGIN(TABLE_STRING);
\>         END_BLOCK("table_tag"); BEGIN(INITIAL);
.|\n
}

 /* strings inside of table tags */
<TABLE_STRING>{
\n         END_BLOCK("table_tag"); BEGIN(INITIAL);
\\.
\"         END_BLOCK("string"); BEGIN(TABLE_TAG);
.
}

<SCRIPT_TAG>{
(.|\n)/\<        END_BLOCK("script_tag"); BEGIN(INITIAL);
\"         BEGIN_BLOCK("string", 1, FALSE); BEGIN(SCRIPT_STRING);
\>         END_BLOCK("script_tag"); BEGIN(INITIAL);
.|\n
}

 /* strings inside of script tags */
<SCRIPT_STRING>{
\n         END_BLOCK("script_tag"); BEGIN(INITIAL);
\\.
\"         END_BLOCK("string"); BEGIN(SCRIPT_TAG);
.
}

<ANCHOR_TAG>{
(.|\n)/\<  END_BLOCK("anchor_tag"); BEGIN(INITIAL);
\"         BEGIN_BLOCK("string", 1, FALSE); BEGIN(ANCHOR_STRING);
\>         END_BLOCK("anchor_tag"); BEGIN(INITIAL);
.|\n
}

  /* strings inside of tags */
<ANCHOR_STRING>{
\n         END_BLOCK("anchor_tag"); BEGIN(INITIAL);
\\.
\"         END_BLOCK("string"); BEGIN(ANCHOR_TAG);
.
}

<IMAGE_TAG>{
(.|\n)/\<  END_BLOCK("image_tag"); BEGIN(INITIAL);
\"         BEGIN_BLOCK("string", 1, FALSE); BEGIN(IMAGE_STRING);
\>         END_BLOCK("image_tag"); BEGIN(INITIAL);
.|\n
}

  /* strings inside of tags */
<IMAGE_STRING>{
\n         END_BLOCK("image_tag"); BEGIN(INITIAL);
\\.
\"         END_BLOCK("string"); BEGIN(IMAGE_TAG);
.
}

<TAG>{
(.|\n)/\<  END_BLOCK("tag"); BEGIN(INITIAL);
\"         BEGIN_BLOCK("string", 1, FALSE); BEGIN(TAG_STRING);
\>         END_BLOCK("tag"); BEGIN(INITIAL);
.|\n
}

<TAG_STRING>{
\n         END_BLOCK("tag"); BEGIN(INITIAL);
\\.
\"         END_BLOCK("string"); BEGIN(TAG);
.
}

	
.|\n	     /* ignore bad characters */