/* start condition definitions */
%x STRING VAR

/* pattern definitions */
D			[0-9]
L			[a-zA-Z_]
H			[a-fA-F0-9]
E			[Ee][+-]?{D}+
FS			(f|F|l|L)
IS			(u|U|l|L)*

%%
 /* patterns */
"#"           BEGIN_BLOCK("comment", 0, FALSE);
"\n"          END_BLOCK ("comment");
	
\"             BEGIN_BLOCK("string", 0, TRUE); BEGIN(STRING);
<STRING>{
  "\n"         END_BLOCK("string"); BEGIN(INITIAL);
  \\.          |
  \\[0-7]{1,3} TOKEN("escape_char", 1);
  \"           END_BLOCK("string"); BEGIN(INITIAL);
  .
}


^[ \t]*use[ \t]* TOKEN("include", 0);

"local" |
"sub"   |
"my"    TOKEN("type", 0);

[\$@\%]             BEGIN(VAR);
<VAR>{
  {L}({L}|{D})*	    TOKEN("variable", 0); BEGIN(INITIAL);
  .                 BEGIN(INITIAL);
}

	
"bless"      |
"caller"     |
"continue"   |
"do"         |
"else"       |
"elsif"      |
"for"        |
"foreach"    |
"goto"       |
"if"         |
"import"     |
"last"       |
"next"       |
"no"         |
"package"    |
"redo"       |
"return"     |
"require"    |
"untie"      |
"until"      |
"unless"     |
"use"        |
"while"      TOKEN("keyword", 0);

"<=>" |
"->"  |
"=>"  |
">"   |
"<"   |
"+"   |
"-"   |
"*"   |
"/"   |
"%"   |
"="   |
"!="  |
"=="  |
"&&"  |
"||"  |
"!"   |
"ge"  |
"le"  |
"gt"  |
"lt"  |
"eq"  |
"ne"  |
"cmp" |
"~"   TOKEN("operator", 0);

";"
"{"
"}"
","
":"

"("
")"
"["
"]"
"."


{L}({L}|{D})*		/* identifier ignore */

	
[ \t\v\n\f]		
.	     /* ignore bad characters */
